#ifndef __BOILERPLATE_PREFERENCES_VIEW_H__
#define __BOILERPLATE_PREFERENCES_VIEW_H__

#include <gtk/gtk.h>

G_BEGIN_DECLS

#define BOILERPLATE_TYPE_PREFERENCES_VIEW (boilerplate_preferences_view_get_type ())

G_DECLARE_FINAL_TYPE (BoilerplatePreferencesView, boilerplate_preferences_view, BOILERPLATE, PREFERENCES_VIEW, GtkBin)

typedef struct _BoilerplatePreferencesGroup {
    GtkWidget *title;
    GtkWidget *box;
    GtkWidget *list_box;
} BoilerplatePreferencesGroup;

BoilerplatePreferencesView *
boilerplate_preferences_view_new (void);

void
boilerplate_preferences_view_add_page (BoilerplatePreferencesView *self,
                                       const gchar                *page_name,
                                       const gchar                *page_title);

GtkWidget *
boilerplate_preferences_view_get_page (BoilerplatePreferencesView *self,
                                       const gchar                *page_name);

void
boilerplate_preferences_view_add_group (BoilerplatePreferencesView *self,
                                       const gchar                 *page_name,
                                       const gchar                 *group_name,
                                       const gchar                 *group_title);

BoilerplatePreferencesGroup *
boilerplate_preferences_view_get_group (BoilerplatePreferencesView *self,
                                        const gchar                *page_name,
                                        const gchar                *group_name);

GtkWidget *
boilerplate_preferences_view_add_row (BoilerplatePreferencesView *self,
                                      const gchar                *page_name,
                                      const gchar                *group_name);
void
boilerplate_preferences_view_add_option (BoilerplatePreferencesView *self,
                                         const gchar                *page_name,
                                         const gchar                *group_name,
                                         const gchar                *title,
                                         const gchar                *subtitle,
                                         GtkWidget                  *widget);

G_END_DECLS

#endif /* __BOILERPLATE_PREFERENCES_VIEW_H__ */
